﻿Imports System.Data.OleDb
Imports System.IO

'C1
Imports C1.Win.C1FlexGrid

Public Class Form2
    Dim SqlStr As String = ""
    Private OleDbdataSet As DataSet
    Private Sub Form2_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        DGLaden()
    End Sub
    Private Sub DGLaden()
        Try
            C1FlexGrid1.DataSource = Nothing
            C1FlexGrid1.Rows.RemoveRange(1, C1FlexGrid1.Rows.Count - 1)

            SqlStr = "SELECT ID, showImage, statuseng FROM status ORDER BY ID"
            Dim conn As String = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=..\..\..\..\tImage.mdb;User Id=admin;Password=;"
            Dim OleDbda As New OleDb.OleDbDataAdapter(SqlStr, conn)
            OleDbdataSet = New DataSet
            OleDbda.Fill(OleDbdataSet, "IListe")
            Dim dt As DataTable = OleDbdataSet.Tables("IListe")
            C1FlexGrid1.DataSource = dt
            DataGridView1.DataSource = dt
            With C1FlexGrid1
                .Cols(1).Caption = "ID"
                .Cols(1).Width = 100
                .Cols(2).Caption = "Image"      'showImage
                .Cols(2).WidthDisplay = 200
                .Cols(3).Caption = "Text"
                .Cols(3).Width = 180
            End With
            C1FlexGrid1.DrawMode = C1.Win.C1FlexGrid.DrawModeEnum.OwnerDraw
            AddHandler C1FlexGrid1.OwnerDrawCell, AddressOf C1FlexGrid1_OwnerDrawCell

            PictureBox1.Image = GetImageFromByteArray(TryCast(dt.Rows(1)("showImage"), [Byte]()))
            C1PictureBox1.Image = LoadImage(TryCast(dt.Rows(2)("showImage"), [Byte]()))
        Catch ex As Exception
            MsgBox("Error 'DGLaden' : " & vbCrLf & ex.ToString, MsgBoxStyle.Critical)
        End Try
    End Sub
    Sub C1FlexGrid1_OwnerDrawCell(sender As Object, e As C1.Win.C1FlexGrid.OwnerDrawCellEventArgs)
        Try
            If (e.Col).Equals(2) AndAlso e.Row > 0 Then
                'e.Image = LoadImage(CType(C1FlexGrid1(e.Row, e.Col), Byte()))
                e.Image = GetImageFromByteArray(TryCast(C1FlexGrid1(e.Row, e.Col), [Byte]()))
                e.Style.ImageAlign = C1.Win.C1FlexGrid.ImageAlignEnum.Stretch
                e.Style.Display = C1.Win.C1FlexGrid.DisplayEnum.ImageOnly
            End If
        Catch ex As Exception
            MsgBox("Error 'C1FlexGrid1_OwnerDrawCell' : " & vbCrLf & ex.ToString, MsgBoxStyle.Critical)
        End Try
    End Sub
    Private Shared Function LoadImage(ByVal picData As Byte()) As Image
        Const bmData As Integer = 78
        If picData Is Nothing OrElse picData.Length < bmData + 2 Then Return Nothing
        If picData(0) <> 21 OrElse picData(1) <> 28 Then Return Nothing
        Dim img As Image = Nothing
        Try
            Dim ms As MemoryStream = New MemoryStream(picData, bmData, picData.Length - bmData)
            img = Image.FromStream(ms)
        Catch
        End Try

        Return img
    End Function
    Private Function GetImageFromByteArray(picData As Byte()) As Image
        Try
            If (picData) Is Nothing Then
                Return Nothing
            End If

            '' is this is an embedded object
            Dim bmData As Integer = If((picData(0) = 21 AndAlso picData(1) = 28), 78, 0)

            '' load the picture    
            Dim img As Image = Nothing
            Try
                Dim ms As New System.IO.MemoryStream(picData, bmData, picData.Length - bmData)
                img = Image.FromStream(ms)

                Return img

            Catch ex As Exception
                'MsgBox("Error 'GetImageFromByteArray' : " & vbCrLf & ex.ToString, MsgBoxStyle.Critical)
            End Try
        Catch
        End Try
    End Function
End Class